#include <awali/dyn/algos/aliases.hh>

namespace awali {
  namespace dyn {

    automaton_t
    eval (automaton_t aut, automaton_t tdc) {
      return image(compose(partial_identity(aut),tdc));
    }

    ratexp_t eval_word(automaton_t tdc, const std::string& word) {
      automaton_t aut = make_automaton("");
      context_t ctx = aut->get_context();
      state_t s=aut->add_state();
      aut->set_initial(s);
      for(unsigned i=0; i<word.length(); ++i) {
	state_t t=aut->add_state();
	ctx->add_letter(word[i]);
	aut->set_transition(s, t, word[i]);
	s=t;
      }
      aut->set_final(s);
      automaton_t res = eval(aut, tdc);
      return aut_to_exp(res);
    }
  }
}
