#include <awali/sttc/algos/product.hh>
#include <awali/dyn/bridge-sttc/explicit-automaton.cc>
#include <awali/common/priority.hh>

#include<set-types.hh>

namespace awali {

  namespace internal {

    template <typename C, typename P>
    dyn::automaton_t power(dyn::automaton_t aut, unsigned n, priority::ONE<P>) {
      throw std::runtime_error("power only supported for free label-sets.");
    }


    template <typename C, typename P>
    auto power(dyn::automaton_t aut, unsigned n, priority::TWO<P>)
    -> typename std::enable_if< C::labelset_t::is_free(), dyn::automaton_t>::type
    {
      auto a = dyn::get_stc_automaton<C>(aut);
      return dyn::make_automaton(sttc::power(a,n));
    }
  }

  extern "C" dyn::automaton_t power(dyn::automaton_t aut, unsigned n) {
      return internal::power<context_t>(aut,n, priority::value);
  }

}

#include <awali/dyn/core/any.cc>
