#ifndef DYN_ABSTRACT_WEIGHTSET_HH
#define DYN_ABSTRACT_WEIGHTSET_HH

#include <awali/sttc/misc/attributes.hh>

#include <awali/dyn/core/context-description.hh>

#include<vector>

namespace awali {
  namespace dyn {

    //Every object of type abstract_weightset has a distinct index and is
    //stored into the instances vector
    struct abstract_weightset {
      static int counter;
      const int index;
      abstract_weightset() : index(counter++) {}

      int getIndex() const{
	      return index;
      }

      virtual const std::string& tostring(weightset_description ws, bool dynamic) const = 0;

      virtual const std::string& static_public_name() const = 0;

      virtual weightset_description fromstring(const std::string &k) const =0;

      virtual weightset_description parse_weightset(std::istream& i) const = 0;

      virtual ~abstract_weightset() {}
    };

    int abstract_weightset::counter=0;
  }
}

#endif
