#ifndef DYN_BASIC_WEIGHTSET_HH
#define DYN_BASIC_WEIGHTSET_HH
#include <awali/dyn/core/context-description/weightsets/abstract-weightset.hh>

namespace awali {
  namespace dyn {


    struct basic_weightset : abstract_weightset {
    private:
      const std::string public_name;
      const std::string class_name;
    public:
      basic_weightset(const std::string& public_name, const std::string& class_name) :
    	public_name(public_name), class_name(class_name) {}

      const std::string& tostring(weightset_description ws, bool dynamic) const {
	return class_name;
      }

  const std::string& static_public_name() const {
    return public_name;
  }

      //Returns an empty shared pointer if the string does not correspond to the weightset
      weightset_description fromstring(const std::string &k) const {
	weightset_description ws;
	if(k==public_name) {
	  ws = make_weightset_description();
	  ws->type_ = index;
	}
	return ws;
      }

      weightset_description parse_weightset(std::istream& i) const {
	return fromstring(sttc::parsestring(i));
      }

    };

  }
}

#endif
