#include <iostream>
#include <unordered_map>

#include <awali/dyn/modules/derivation.hh>

namespace awali { namespace dyn {
/*
 TODO
  std::map<ratexp_t, weight_t> derivation(std::map<ratexp_t, weight_t> e, label_t a, bool breaking = false)
  std::map<ratexp_t, weight_t> derivation(std::map<ratexp_t, weight_t> e, std::string w, bool breaking = false)
  */

  std::map<ratexp_t, weight_t> derivation(ratexp_t exp, label_t a, bool breaking) {
    std::string stat_ctx = exp->get_context()->sname();
    typedef std::map<ratexp_t, weight_t> (*bridge_t)(ratexp_t, label_t, bool);
    static std::unordered_map<std::string, bridge_t> bridges;
    auto it = bridges.find(stat_ctx);
    if(it == bridges.end()) {
      auto bridge = (bridge_t) loading::get_handler("derivation_label", "derivation", stat_ctx);
      bridges.emplace(stat_ctx, bridge);
      return bridge(exp, a, breaking);
    }
    else
      return it->second(exp, a, breaking);
  }

  automaton_t derived_term(ratexp_t exp, bool breaking, bool keep_history) {
    std::string stat_ctx = exp->get_context()->sname();
    typedef automaton_t (*bridge_t)(ratexp_t, bool, bool);
    static std::unordered_map<std::string, bridge_t> bridges;
    auto it = bridges.find(stat_ctx);
    if(it == bridges.end()) {
      auto bridge = (bridge_t) loading::get_handler("derived_term", "derivation", stat_ctx);
      bridges.emplace(stat_ctx, bridge);
      return bridge(exp, breaking, keep_history);
    }
    else
      return it->second(exp, breaking, keep_history);
  }

}}//end of ns awali::dyn
