#ifndef DYN_DETERMINIZE_HH
#define DYN_DETERMINIZE_HH

#include <awali/dyn/core/automaton.hh>

//This module must not be used with zmin or zmax...
//Only for lal automata

namespace awali { namespace dyn {

  //Boolean automata only
  automaton_t determinize(automaton_t aut, bool history = true);
  automaton_t complement(automaton_t aut);
  void complement_here(automaton_t aut);
  automaton_t complete(automaton_t aut);
  void complete_here(automaton_t aut);

  //Automata over fields or z only
  automaton_t reduce(automaton_t aut);
  automaton_t left_reduce(automaton_t aut);

  bool is_deterministic(automaton_t aut);
  bool is_complete(automaton_t aut);
  bool is_ambiguous(automaton_t aut);

}}//end of ns awali::dyn

#endif
