#ifndef DYN_MODULES_GRAPH_HH
#define DYN_MODULES_GRAPH_HH

#include <unordered_map>
#include <vector>

#include <awali/dyn/core/automaton.hh>

namespace awali { namespace dyn {

  std::pair< std::unordered_map<state_t, unsigned int>,
            std::vector<std::vector<state_t>> > scc_recursive(automaton_t);
  std::pair< std::unordered_map<state_t, unsigned int>,
            std::vector<std::vector<state_t>> > scc_iterative(automaton_t);
  std::pair<  automaton_t,
            std::pair< std::unordered_map<state_t, unsigned int>,
                       std::vector<std::vector<state_t>> >  >
                                            condensation (automaton_t aut);

  std::vector<state_t> scc_of(automaton_t aut, state_t s);
}}//end of ns awali::dyn

#endif
