#ifndef DYN_MODULES_MINIMIZE_CC
#define DYN_MODULES_MINIMIZE_CC

#include <vector>
#include <unordered_set>
#include <sstream>
#include <iomanip>
#include <stdexcept>

#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/loading/handler.hh>

#include <awali/dyn/modules/minimize.hh>
#include <awali/dyn/modules/derivation.hh>

namespace awali {
  namespace dyn {
    //Boolean automata only
    automaton_t minimal_automaton(automaton_t aut, param_t algo) {
      return loading::call2<automaton_t, param_t, &minimal_automaton>("minimal_automaton", "minimize", aut, algo);
    }

    automaton_t minimal_automaton(ratexp_t exp, param_t algo) {
      return minimal_automaton(derived_term(exp, false, true), algo);
    }
  }
}//end of ns awali::dyn

#endif
