#include <awali/dyn.hh>
#include<cassert>

using namespace awali::dyn;

int main() {
  automaton_t aut = de_bruijn(4,'0');
  assert(aut->num_states() == 5);
  aut = divkbaseb(5, 2, '0');
  assert(aut->num_states() == 5);
  aut = double_ring(6, {0,2,3});
  assert(aut->num_states() == 6);
  assert(aut->num_finals() == 3);
  aut = witness(5);
  assert(aut->num_states() == 5);
  aut = cerny(5);
  assert(aut->num_states() == 5);
  aut = ladybird(5);
  assert(aut->num_states() == 5);
}
