#ifndef AWALI_ALGOS_MINIMIZE_BRZOZOWSKI_HH
# define AWALI_ALGOS_MINIMIZE_BRZOZOWSKI_HH

#include <awali/sttc/algos/determinize.hh>
#include <awali/sttc/core/transpose-view.hh>

namespace awali { namespace sttc {


  /*-------------------------------------------.
  | minimization with Brzozowski's algorithm.  |
  `-------------------------------------------*/

  template <typename Aut>
  inline
  typename Aut::element_type::automaton_nocv_t
  minimize_brzozowski(const Aut& a)
  {
    auto codet = determinize(transpose_view(a),false);
    return determinize(transpose_view(codet),false);
  }

}}//end of ns awali::stc

#endif // !AWALI_ALGOS_MINIMIZE_BRZOZOWSKI_HH
