#ifndef AWALI_CORE_FWD_HH
# define AWALI_CORE_FWD_HH

#include <awali/sttc/misc/memory.hh> // make_shared_ptr.

namespace awali { namespace sttc {


  // sttc/core/crange.hh
  template <class C>
  struct container_range;

  template <class C>
  struct container_filter_range;


  // sttc/core/mutable-automaton.hh
  namespace internal
  {
    template <typename Context>
    class mutable_automaton_impl;
  }
  template <typename Context>
  using mutable_automaton
    = std::shared_ptr<internal::mutable_automaton_impl<Context>>;


  // sttc/core/permutation-automaton.hh.
  namespace internal
  {
    template <typename Aut>
    class permutation_automaton_impl;
  }
  template <typename Aut>
  using permutation_automaton
    = std::shared_ptr<internal::permutation_automaton_impl<Aut>>;


  // sttc/core/ratexp-automaton.hh.
  namespace internal
  {
    template <typename Aut>
    class ratexp_automaton_impl;
  }
  template <typename Aut>
  using ratexp_automaton
    = std::shared_ptr<internal::ratexp_automaton_impl<Aut>>;

}}//end of ns awali::stc

#endif // !AWALI_CORE_FWD_HH
