#ifndef AWALI_MISC_BITSET_HH
#define AWALI_MISC_BITSET_HH

#include<bitset>

namespace awali { namespace sttc {

  template<size_t N>
  struct bitset_iterator {
          private:
          const std::bitset<N>& bs_;
          size_t current_ = 0u;
          public:
          bitset_iterator<N>(const std::bitset<N>& bs) : bs_(bs) {}

          bool has_next() {
                  while(current_ < N && !bs_.test(current_))
                          ++current_;
                  return (current_ < N);
          }

          size_t next() {
                  while(current_ < N && !bs_.test(current_))
                          ++current_;
                  return current_++;
          }

  };

  template<size_t N>
  auto get_iterator(const std::bitset<N>& bs) -> bitset_iterator<N> {
          return {bs};
  }

}}//end of ns awali::stc
#endif
