#ifndef UTILS_ARITH_HH
#define UTILS_ARITH_HH

#include <awali/sttc/misc/attributes.hh>

namespace awali { namespace utils {
  // Greatest common divisor.
  ATTRIBUTE_CONST
  unsigned int gcd(unsigned int a, unsigned int b)
  {
    while (b)
    {
      unsigned int t = a;
      a = b;
      b = t % b;
    }
    return a;
  }

  // Lowest common multiple
  ATTRIBUTE_CONST
  unsigned int lcm(unsigned int a, unsigned int b)
  {
    return a / gcd(a, b) * b;
  }

  ATTRIBUTE_CONST
  int min(int a, int b) {
    return (a<b?a:b);
  }

  ATTRIBUTE_CONST
  int max(int a, int b) {
    return (a>b?a:b);
  }

}}//end of ns awali::utils



#endif
