from distutils.core import setup, Extension
from Cython.Build import cythonize
import os;

#os.environ["CC"] = "${CMAKE_CXX_COMPILER}"

##### A hack to remove the pesky -W-strict-prototypes argument which makes
##### g++ issue a warning: the flag makes no sense for compiling c++.
from distutils.command.build_ext import build_ext
from distutils.sysconfig import customize_compiler

class hacked_build_ext(build_ext):
    def build_extensions(self):
        customize_compiler(self.compiler)
        try:
            self.compiler.compiler_so.remove("-Wstrict-prototypes")
        except (AttributeError, ValueError):
            pass
        build_ext.build_extensions(self)
##### (The following line, lower in the file, must also be deleted
#####     cmdclass = {'build_ext': hacked_build_ext},
##### )
##### End of Hack

cython_module = \
    Extension(
        'awalipy',
        sources=['cython-src/awalipy.pyx'],
       include_dirs=['..'],
#                      '${CMAKE_BINARY_DIR}', ],
#        library_dirs=['${AWALI_INST_DYNLIB_PATH}', '${AWALI_DYNLIB_PATH}'],
        libraries=['awalidyn'],
        language="c++",
        extra_compile_args=["-std=c++11", "-O3"],
#        runtime_library_dirs=['${AWALI_INST_DYNLIB_PATH}', '${AWALI_DYNLIB_PATH}'],
    )
#cython_module.cython_c_in_temp = True

setup(
    cmdclass = {'build_ext': hacked_build_ext},
    name = "awalipy",
    version = '0.4',
    ext_modules =  cythonize(cython_module),
    py_modules=['awalipy_purepython_extra'],
)
